# Passes

This document describes the available MLIR passes and their contracts.

[TOC]

## General Transformation Passes

[include "GeneralPasses.md"]

## Bufferization Passes

[include "BufferizationPasses.md"]

## Conversion Passes

[include "ConversionPasses.md"]

## 'affine' Dialect Passes

[include "AffinePasses.md"]

## 'amdgpu' Dialect Passes

[include "AMDGPUPasses.md"]

## 'arith' Dialect Passes

[include "ArithPasses.md"]

## 'arm\_sme' Dialect Passes

[include "ArmSMEPasses.md"]

## 'arm\_sve' Dialect Passes

[include "ArmSVEPasses.md"]

## 'async' Dialect Passes

[include "AsyncPasses.md"]

## 'func' Dialect Passes

[include "FuncPasses.md"]

## 'gpu' Dialect Passes

[include "GPUPasses.md"]

## 'linalg' Dialect Passes

[include "LinalgPasses.md"]

## 'llvm' Dialect Passes

[include "LLVMPasses.md"]

## 'math' Dialect Passes

[include "MathPasses.md"]

## 'memref' Dialect Passes

[include "MemRefPasses.md"]

## 'ml\_program' Dialect Passes

[include "MLProgramPasses.md"]

## 'nvgpu' Dialect Passes

[include "NVGPUPasses.md"]

## Reducer Passes

[include "ReducerPasses.md"]

## 'scf' Dialect Passes

[include "SCFPasses.md"]

## 'shape' Dialect Passes

[include "ShapePasses.md"]

## 'sparse_tensor' Dialect Passes

[include "SparseTensorPasses.md"]

## 'spv' Dialect Passes

[include "SPIRVPasses.md"]

## 'tensor' Dialect Passes

[include "TensorPasses.md"]

## 'transform' Dialect Passes

[include "TransformPasses.md"]

## 'vector' Dialect Passes

[include "VectorPasses.md"]

## TOSA Dialect Passes

[include "TosaPasses.md"]
